config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: {
    sessions: 'users/sessions',
    registrations: 'users/registrations'
  }
  resources :couples, except: [:index, :new]
  resources :verification_codes
  resources :scores, except: [:index]
  resources :match_players, except: [:new, :index, :edit]
  resources :matches, except: [:index, :destroy, :edit]
  resources :events
  
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  root "events#dashboard"

  # route for a new match-player with a specific event
  get 'match_players/new/:id', to: "match_players#new", as: 'new_match_player'
  get "match_players/edit/:id/(:resend)", to: "match_players#edit", as: "edit_match_player"
  # route to show the players for a specific event
  get 'match_players/index/:id', to: "match_players#index", as: 'players_enrolled'

  
  
  get 'matches/index/:id/(:round)', to: "matches#index", as: 'event_matches'
  get 'matches/player_matches/:event_id/:player_id', to: "matches#player_matches", as: 'player_matches'
  delete "matches/:event_id/:round", to: "matches#destroy", as: "matches_destroy_round"
  get 'matches/create_round_of_matches/:event_id', to: "matches#create_round_of_matches", as: 'create_round_of_matches'
  
  patch "events/update_status/:id", to: "events#update_status", as: "update_status_event"
  get "event/show_closed_event/:id", to: "events#show_closed_event", as: "show_closed_event"
  get "matches/edit/:id/:round", to: "matches#edit", as: "edit_match"
  get "scores/index/:id", to: "scores#index", as: "player_scores"
  
  get "players/new/(:event_id)", to: "players#new", as: "new_player"
  resources :players, except: [:new]
  
  #resources :players do
  #  get "players/new/(:event_id)", to: "players#new", as: "new_player", on: :collection
  #end
  
  get 'couples/index/:id', to: "couples#index", as: 'event_couples'
  get "couples/new/:id", to: "couples#new", as: "new_couple"
  get "players/dashboard/:player_id", to:  "players#dashboard", as: "dashboard_player"
  get "events/dashboard", to: "events#dashboard", as: "dashboard_events"
  #comment x
end 

app/models/match_player.rb
class MatchPlayer < ApplicationRecord
  #This model keeps the players who are onboard for one particular event.  
  belongs_to :event
  belongs_to :player
  STATUS= %w[OnBoard OnHold Canceled] #Status
  validates :player, uniqueness: { scope: :event, message: "This player is already enroled on the event" }
  after_destroy :set_player_status

  def setStatus 
    #Set the status to the MatchPlayer depending on the qty players who have been signed in into the event
    event = Event.find(self.event_id)
    #We get the onboard players
    obPlayers = MatchPlayer.where(event_id: event.id).select{|mp| mp.status== 'OnBoard'}.count
    if obPlayers < event.people
      self.status = 'OnBoard'
    elsif obPlayers >= event.people
      self.status = 'OnHold'
    end    
  end
  def set_player_status
    #update the status (to onboard) of the first onhold player of the event
    #Note: this method will only change the status if the player had OnBoard Status
    event = Event.find(self.event_id)
    if (event.onlyLeft == 1) && (MatchPlayer.where(event_id: event.id, status: "OnHold").count >=1 )
      mp = MatchPlayer.where(event_id:event.id, status: "OnHold").sort_by{|mp| mp.created_at}.first
      
      # Player who change status
      @player = mp.player
      puts "-----------------------------------------------------------------------------------"
      puts "The player #{@player.id} - #{@player.name} has changed status from 'OnHold' to 'OnBoard's"
      puts "-----------------------------------------------------------------------------------"
      mp.status = 'OnBoard'
      send_sms_status_change if mp.save!
    end    
  end

  def send_sms_status_change
    event = Event.find(self.event_id)    
    message = "From Padel Crazy X - Hello #{@player.name.titleize}, You are now OnBoard! for the Padel event: #{event.name} on #{event.eventDate.strftime('%d/%m/%Y')} from #{event.timeIni.strftime('%H:%M')} to #{event.timeEnd.strftime('%H:%M')}"
    sms = Message.new(number: @player.cellphone, body: message, action: "send_sms_status_change", controller: "match_player.rb")
    result = sms.send_sms
    sms.error = result.error_message
    sms.save!    
  end

  #def addVerifiedCallerId
    #this method adds a new caller Id such as my girl mobile phone number 442 3279641
  #  account_sid = 'ACc08ca94532b4f7c849560154f0269a40'
  #  auth_token = '9dfec69d0c13fcfe9bb89748c7617421'
  #  @client = Twilio::REST::Client.new(account_sid, auth_token)
  #  validation_request = @client.validation_requests.create(friendly_name: 'My girl mobile number',phone_number: '+524423279641')
  #  puts validation_request.friendly_name
  #end

end

app/controllers/match_players_controller.rb
class MatchPlayersController < ApplicationController
  before_action :set_match_player, only: %i[ show edit destroy edit update ] 
  # GET /match_players or /match_players.json
  def index
    @match_players = MatchPlayer.where(event_id: params[:id])
    @event = Event.find(params[:id])
  end

  # GET /match_players/1 or /match_players/1.json
  def show
    #render layout: "empty"
  end

  # GET /match_players/new
  def new
    @event = Event.find(params[:id])    
    @match_player = MatchPlayer.new
    #render layout: "empty"
  end

  # POST /match_players or /match_players.json
  def create
    #Validations
    mp = MatchPlayer.create(match_player_params)
    respond_to do |format|      
      if !mp.errors.messages.any?      
        mp.setStatus
        mp.save!
        format.html { redirect_to match_player_url(mp), notice: "You have joined succesfully to the event"}
        format.json { render :show, status: :created, location: @match_player }
      else
        event_id =  match_player_params[:event_id]
        #format.html { render :new, status: :unprocessable_entity}
        #flash[:notice] = result_saving.errors.full_messages.to_sentence
        #flash[:notice]="some error"        
        format.html {redirect_to new_match_player_url(event_id), notice: mp.errors}
        format.json { render json: @match_player.errors, status: :unprocessable_entity }
      end
    end
  end
  
  # GET /match_players/1/edit
    def edit
    #Debo validar la existencia de algun codigo previo. 
    #Eliminar todos los existentes y crear uno nuevo y despues enviar este codigo a la pantalla de editar    
    @match_player.player.VerificationCodes.where(used: false).destroy_all
    @verification_code = VerificationCode.create(code: SecureRandom.random_number(1000..9999), player_id: @match_player.player_id, event_id: @match_player.event_id)
    
    #We must send the verification code to the cellphone
    message = "From Padel Crazy X - This is your verification code: " << @verification_code.code.to_s
    sms = Message.new(number: @match_player.player.cellphone, body: message, action: "edit_verification_code", controller: "MatchPlayersController")
    result = sms.send_sms
    sms.error = result.error_message
    sms.save!

    flash.now[:notice] = "From Padel Crazy X - We've send you another code, please check your messages!'" if params[:resend] == "true"
    #logger.debug "------------- Hello there resend = True #{params[:resend]}    ------------"
    render(layout: "empty")
    
  end
  
    # PATCH/PUT /match_players/1 or /verification_codes/1.json
  def update
      @verification_code = VerificationCode.find(params[:match_player][:verification_id])
      if params[:match_player][:code].to_i == @verification_code.code    
        #se actualiza el codigo a usado=true
        @verification_code.used = true
        
        #se elimina al player del evento
        @match_player.destroy
        respond_to do |format|    
          if @verification_code.save
            #format.html { redirect_to verification_code_url(@verification_code), notice: "Verification code was successfully updated." }
            format.html { redirect_to new_match_player_path(@match_player.event_id), notice: "The player has been successfully withdrawn from the event." }
            #format.json { render :show, status: :ok, location: @verification_code }
          else
            format.html { render :edit, status: :unprocessable_entity }
            format.json { render json: @verification_code.errors, status: :unprocessable_entity }
            format.turbo_stream { render :form_update, status: :unprocessable_entity }        
          end
        end  
      else      
        respond_to do |format|
          flash.now[:notice] = "The verification code does not match or is no longer valid. Try again."
          format.html { render :edit, status: :unprocessable_entity, notice: "The verification code does not match or is no longer valid. Try again." }
          format.json { render json: @verification_code.errors, status: :unprocessable_entity }
          format.turbo_stream { render :form_update, status: :unprocessable_entity }  
        end        
      end      
  end

  # DELETE /match_players/1 or /match_players/1.json
  def destroy
    @match_player.destroy

    respond_to do |format|
      format.html { redirect_to match_players_url, notice: "Match player was successfully destroyed." }
      format.json { head :no_content }
    end
  end
  private
    # Use callbacks to share common setup or constraints between actions.
    def set_match_player
      @match_player = MatchPlayer.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def match_player_params
      params.require(:match_player).permit(:event_id, :player_id, :status, :code)
    end
end

app/helpers/match_players_helper.rb
module MatchPlayersHelper
end

app/views/match_players/_form.html.erb
<div class="row>
    <div class="page-header align-items-start min-vh-50 pt-5 pb-11 m-3 border-radius-lg">
      <span ></span>
      <div class="container">
        <div class="row justify-content-center">
          <div class="col-lg-5 text-center mx-auto">
            <h1 class="text-white mb-2 mt-5">&nbsp;</h1>
            <p class="text-lead text-white">&nbsp;</p>
            
          </div>
        </div>
      </div>
    </div>


    <div class="container">
      <div class="row mt-lg-n10 mt-md-n11 mt-n10 justify-content-center">
        <div class="col-xl-4 col-lg-5 col-md-7 mx-auto">
          <div class="card z-index-0">
            <div class="card-header text-center pt-4">
              <h5>Enroll event or <%= link_to "enroll other", root_path,  class: "text-info text-gradient font-weight-bold" %></h5>              
            </div>
            <div class="card-header">
              <ul class="list-group">
                <li class="list-group-item text-sm">Event: <strong><%=event.name%> [ID: <%=event.id%>]</strong></li>
                <li class="list-group-item text-sm">Date: <strong><%=event.eventDate.strftime("%d/%m/%Y") %> </strong></li>
                <li class="list-group-item text-sm">Scheduled: <strong><%=event.timeIni.strftime("%H:%M")%> - <%=event.timeEnd.strftime("%H:%M")%> </strong></li>
                <li class="list-group-item text-sm">Players: <strong><%=event.people%> </strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Only left: <strong><%=event.onlyLeft%></strong></li>
                <li class="list-group-item text-sm">Category: <strong><%=event.level%>&nbsp;&nbsp;
                  <%if  event.mixed   %>
                    Mixed
                  <%else%>
                    Fixed
                  <%end%>
                  Couples</strong>
                </li>                
              </ul>                                          
            </div>
            <!-- Button trigger modal -->
            <div class="text-center">
              <button type="button" class="btn btn-sm bg-gradient-success" data-bs-toggle="modal" data-bs-target="#exampleModal">See enrolled players</button>
            </div>
            
              
            
            <div class="card-body">
              <%= form_with(model: match_player) do |f| %>
                <% if match_player.errors.any? %>
                  <div style="color: red">
                    <h2><%= pluralize(match_player.errors.count, "error") %> prohibited this event from being saved:</h2>

                    <ul>
                      <% match_player.errors.each do |error| %>
                        <li><%= error.full_message %></li>
                      <% end %>
                    </ul>
                  </div>
                <% end %>
                <div class="mb-3">                
                  <p class="text-s mt-3 mb-0">Type your cellphone or full name</p>                
                  <%= f.text_field :event_id, value: event.id,  style: "#{'display:none'}"%>
                  
                  <%= f.select :player_id, options_for_select(Player.where.not({ id: event.match_player.collect{|mp| mp.player.id}}).order(:name).collect { |player|
                                                                   [(player.cellphone? ? player.try(:cellphone):'no cellphone') + "-" + player.name.titleize , player.id] }, @match_player.player_id), {}, {id: 'select2_player_id_mobile',class:"form-control ms-auto",  required: true} %>
                  <%= button_tag(type: 'submit', class: "btn bg-gradient-primary w-100 my-4 mb-2") do %>
                        <i class="fa fa-check"></i>&nbsp;&nbsp;Enroll event
                  <% end %>
                </div>
                <p class="text-sm mt-3 mb-0">Your cellphone does not appear?
                <%= link_to "Register here", new_player_path(event),  class: "text-info text-gradient font-weight-bold" %>
                 </p>
              <%end%>
            </div>
          </div>
        </div>
      </div>
    </div>
  
</div>








<!-- Modal Enrolled Players-->
<div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalLabel">Enrolled players to "<%=event.name%>" [ID: <%=event.id%>]</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">        
        <div class="card">
          <div class="table-responsive">
            <table class="table align-items-center mb-0">
              <thead>
                <tr>
                  <th class="text-uppercase text-secondary text-xxs font-weight-bolder opacity-7">#</th>
                  <th class="text-uppercase text-secondary text-xxs font-weight-bolder opacity-7">Player</th>
                  <th class="text-uppercase text-secondary text-xxs font-weight-bolder opacity-7">Status</th>
                  <th class="text-uppercase text-secondary text-xxs font-weight-bolder opacity-7"></th>
                </tr>
              </thead>
              <tbody>
                <% (event.match_player.all.sort_by{|p| p.created_at}).each.with_index(1) do | mp, i |%>
                  <tr>
                    <td>
                      <p class="text-xs font-weight-bold mb-0"><%=i%></p>
                    </td>                  
                    <td>
                      <div class="d-flex px-2 py-1">
                        <div>
                          <%if !mp.player.image_attachment.nil?%>
                            <%= image_tag(mp.player.image, class: "avatar avatar-sm me-3") if !mp.player.image_attachment.nil? %>
                          <%else%>
                            <%= image_tag("blank-profile-picture.jpg", class: "avatar avatar-sm me-3")%>
                          <%end%>                          
                        </div>
                        <div class="d-flex flex-column justify-content-center">
                          <h6 class="mb-0 text-xs"><%=mp.player.name.titleize%></h6>
                          <p class="text-xs text-secondary mb-0"><%=mp.player.cellphone%></p>
                        </div>
                      </div>
                    </td>
                    <td>
                      <div>
                        <div>
                          <%if mp.status=='OnBoard' %>
                            <span class="badge badge-sm bg-gradient-success"><%=mp.status%></span>
                          <%else%>
                            <span class="badge badge-sm bg-gradient-danger"><%=mp.status%></span>
                          <%end%>
                          <p class="text-xs font-weight-bold mb-0"><%= local_time(mp.created_at, %"%d/%m/%Y")%></p>
                          <p class="text-xs font-weight-bold mb-0"><%= local_time(mp.created_at, "%H:%M:%S")%></p>
                          
                        </div>
                      </div>
                    </td>                                          
                    <td>                      
                      <%= link_to(edit_match_player_path(mp.id), class: "text-sm text-danger text-gradient text-bold", data: { turbo_frame: "validation_code_modal" }) do %>
                        Quit&nbsp;&nbsp;<i class="fa fa-sign-out"></i>
                      <%end%>
                    </td>
                  </tr>
                <%end%>
              </tbody>
            </table>
          </div>
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn bg-gradient-secondary" data-bs-dismiss="modal">
           <i class="fa fa-times"></i>&nbsp; Close
        </button>        
        
        
      </div>
    </div>
  </div>
</div>
<script type="text/javascript">
  // In your Javascript (external .js resource or <script> tag)
  $(document).ready(function() {
      //$('.js-example-basic-single').select2();
      $('#select2_player_id').select2();
      $('#select2_event_id').select2();

      $('#select2_player_id_mobile').select2();
  });
</script>

app/views/match_players/_form_verification_code.html.erb
<!-- Modal -->
<div class="card card-plain">
  <div class="card-header pb-0 text-left">  
  <% unless notice.nil? %>
    <div class="alert alert-success alert-dismissible fade show" role="alert" style= "color:white" >
      <strong>
        <%= notice %>
        <%= alert %>
      </strong>
      <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close">
          <span aria-hidden="true">&times;</span>
      </button>
    </div>      
  <% end %>
    <h3 class="font-weight-bolder text-danger text-gradient">Quit Event</h3>
    <p class="mb-0"> <%=verification_code.player.name.titleize%>, we've sent you a verification code to the cellphone end with ***<%=verification_code.player.cellphone[-4..-1]%></p>
  </div>
  <div class="card-body">
    <%= form_with(model: match_player) do |f| %>
      <% if match_player.errors.any? %>
        <div style="color: red">
          <h2><%= pluralize(match_player.errors.count, "error") %> prohibited this event from being saved:</h2>
          <ul>
            <% match_player.errors.each do |error| %>
              <li><%= error.full_message %></li>
            <% end %>
          </ul>
        </div>
      <% end %>

      <label>Verification code</label>
      <div class="input-group mb-3">
        <%= f.number_field :code, class: "form-control", value: "" , required: true %>
      </div>
      <div class="input-group mb-3">
        <%= f.hidden_field :event_id %>
        <%= f.hidden_field :player_id%>
        <%= f.hidden_field :verification_id, :value => verification_code.id %>
      </div>
          
      <div class="text-center">
        <%= button_tag(type: 'submit', data: {turbo: false}, class:"btn btn-round bg-gradient-danger btn-lg w-100 mt-4 mb-0") do %>
           Confirm Quit &nbsp;&nbsp;&nbsp;<i class="fa fa-sign-out"></i> 
          
      <% end %> 
      </div>

    <% end %>
      
    
  </div>
  <div class="card-footer text-center pt-0 px-lg-2 px-1">
    <p class="mb-4 text-sm mx-auto">
      Did not receive a code?
      
      <%= link_to "Resend new code", edit_match_player_path(match_player.id, true), class: "text-info text-gradient font-weight-bold", data: { turbo_frame: "validation_code_modal" }%>
    </p>
  </div>
  <div class="modal-footer">    
    <%= link_to(new_match_player_path(verification_code.event_id), data: {turbo: false} , class: "btn bg-gradient-secondary") do %>
      <i class="fa fa-times"></i> Close
    <% end %>
  </div>
</div>

app/views/match_players/_match_player.html.erb
<div class="row>
    <div class="page-header align-items-start min-vh-50 pt-5 pb-11 m-3 border-radius-lg">
      <span ></span>
      <div class="container">
        <div class="row justify-content-center">
          <div class="col-lg-5 text-center mx-auto">
            <h1 class="text-white mb-2 mt-5">&nbsp;</h1>
            <p class="text-lead text-white">&nbsp;</p>
            
          </div>
        </div>
      </div>
    </div>


    <div class="container">
      <div class="row mt-lg-n10 mt-md-n11 mt-n10 justify-content-center">
        <div class="col-xl-4 col-lg-5 col-md-7 mx-auto">
          <div class="card z-index-0">
            <div class="card-header text-center pt-4">            
              <h5>You are now                
                <% case @match_player.status%>
                  <%when 'OnBoard'%> 
                    <strong class= "text-success"> <%=@match_player.status%>! </strong>
                  <%when 'OnHold'%> 
                    <strong class= "text-info"> <%=@match_player.status%>! </strong>
                  <%else%>
                    <strong class= "text-danger"> <%=@match_player.status%>! </strong>
                <%end%>
              </h5>              
            </div>
            <div class="card-body pt-4 p-3">
              <ul class="list-group">
                <li class="list-group-item border-0 d-flex p-4 mb-2 bg-gray-100 border-radius-lg">
                  <div class="d-flex flex-column">
                    <h6 class="mb-3 text-sm"><%=@match_player.player.name.titleize%></h6>
                    <span class="mb-2 text-xs">Event: <span class="text-dark font-weight-bold ms-sm-2"><%=@match_player.event.name%></span></span>
                    <span class="mb-2 text-xs">Date: <span class="text-dark ms-sm-2 font-weight-bold"><%=@match_player.event.eventDate.strftime("%d/%m/%Y")%></span></span>
                    <span class="mb-2 text-xs">Scheduled: <span class="text-dark ms-sm-2 font-weight-bold"><%=@match_player.event.timeIni.strftime("%H:%M")%> - <%=@match_player.event.timeEnd.strftime("%H:%M")%> Hrs</span></span>
                    <span class="mb-2 text-xs">Players: <span class="text-dark ms-sm-2 font-weight-bold"><%=@match_player.event.people%></span></span>
                    <span class="mb-2 text-xs">Category: <span class="text-dark font-weight-bold ms-sm-2">4a - 5a</span></span>                  
                  </div>                  
                </li>
                
              </ul>
              <div class="container">
                <div class="row">
                  <div class="col">
                    <%= link_to(new_match_player_path(@match_player.event), class: "btn bg-gradient-primary") do %>
                        <i class="fa fa-plus-square"></i>&nbsp;&nbsp;Enroll player
                      <% end %>
                  </div>
                  
                  <div class="col">
                    <%= link_to( @match_player, data: {turbo_method: :delete, turbo_confirm: 'Are you sure?'}, class: "btn bg-gradient-danger") do %>
                      <i class="fa fa-sign-out"></i>&nbsp;&nbsp;Quit event                    
                    <% end %>   
                  </div>
                </div>
              </div>
              
            </div>            
          </div>
        </div>
      </div>
    </div>
  
</div>

app/views/match_players/edit.html.erb
<%= render "validation_code_modal", title: "" do %>

  <%= render "form_verification_code", {verification_code: @verification_code, match_player: @match_player} %>

<% end %> 

app/views/match_players/form_update.turbo_stream.erb
<%= turbo_stream.update "remote_modal_body" do %>
  <%= render "form_verification_code", {verification_code: @verification_code, match_player: @match_player} %>
<% end %>

app/views/match_players/index.html.erb
<div class="col-md-12"> 
    <div class="card"><!-- EVENT DETAILS -->
        <div class="card-header pb-0 p-3">
            <div class="d-flex align-items-center">
                <h5 class="mb-0 text-primary">Enrolled Players</h5>
                  <% if @event.status.upcase != "CLOSED"%>
                  <div class="dropdown ms-auto">
                          <button type="button" class="btn bg-gradient-primary dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false">
                            Action
                          </button>
                          <ul class="dropdown-menu px-2 py-3" aria-labelledby="dropdownMenuButton">
                            <li>                              
                              <%= link_to(new_match_player_path(@event), class: "dropdown-item") do %>
                                    Enroll player&nbsp;&nbsp;<i class="fa fa-address-card-o"></i>
                              <%end%>                              
                            </li>                              
                            <li>
                              <% if @event.mixed == false%>
                                <%= link_to(event_couples_path(@event), class: "dropdown-item") do %>
                                      Event couples&nbsp;&nbsp;<i class="fa fa-users"></i>
                                <%end%>
                              <%end%>
                            </li>
                          </ul>
                  </div>



                    
                    
                <%else%>
                    <%= link_to(events_path(@event), class: "btn bg-gradient-primary ms-auto") do %>
                          <i class="fa fa-list"></i>&nbsp;&nbsp;Event list
                    <%end%>
                <%end%>
            </div>            
        </div>
        <div class="card-body p-3">
            <div class="row">
                <div class="col-6">
                    <ul class="list-group">
                        <li class="list-group-item border-0 ps-0 pt-0 text-sm"><strong class="text-dark">Event Name:</strong> &nbsp; [<%=@event.id%>]&nbsp;<%=@event.name.titleize%>&nbsp;
                            <span class="badge badge-pill badge-lg bg-gradient-danger"><%="CLOSED" if @event.status.upcase == "CLOSED"%></span>
                        </li>
                        <li class="list-group-item border-0 ps-0 text-sm"><strong class="text-dark">Date:</strong> &nbsp; <%=local_time(@event.created_at, %"%d/%m/%Y") %> at <%=@event.timeIni.strftime("%H:%M")%> - <%=@event.timeEnd.strftime("%H:%M")%></li>
                        <li class="list-group-item border-0 ps-0 text-sm"><strong class="text-dark">Couples:</strong> &nbsp; <%=(@event.mixed? ? "MIXED":"FIXED" ) %>&nbsp;
                              <strong class="text-dark">Category:</strong>&nbsp; <%=@event.level%>&nbsp;
                              <strong class="text-dark">Max Players:</strong>&nbsp; <%=@event.people%>
                        </li>
                        
                    </ul>
                </div>                
            </div>
        </div>
    </div>
    
    <div class="col-md-12">
        <br>
    </div>

    <div class="row">
        <div class="col-12">
          <div class="card mb-4">
          <div class="d-flex px-2 py-1">
          </div>
            
            
            
          <div class="card-body px-0 pt-0 pb-2">
              <div class="table-responsive p-0">
                <table class="table align-items-center mb-0">
                  <thead>
                    <tr>                      
                      <th class="text-uppercase text-primary text-s font-weight-bolder">#</th>
                      <th class="text-uppercase text-primary text-s font-weight-bolder">Player</th>
                      <th class="text-uppercase text-primary text-s font-weight-bolder">Status</th>
                      <th class="text-uppercase text-primary text-s font-weight-bolder">Enrolled date</th>
                      <th class="text-uppercase text-primary text-s font-weight-bolder">&nbsp;&nbsp;&nbsp;</th>                      
                    </tr>
                  </thead>
                  <tbody>
                  <% @match_players.all.sort_by{|mp| mp.created_at}.each.with_index(1).each do | mp, i |%>
                    <tr>
                      <td>
                        <p class="text-xs font-weight-bold mb-0"><%=i%></p>
                      </td>
                      <td>                      
                        <div class="d-flex px-2 py-1"> 
                          <div>
                            <%if !mp.player.image_attachment.nil?%>
                              <%= image_tag(mp.player.image, class: "avatar avatar-sm me-3")%>
                            <%else%>
                              <%= image_tag("blank-profile-picture.jpg", class: "avatar avatar-sm me-3")%>
                            <%end%>                            
                          </div>
                          <div class="d-flex flex-column justify-content-center">
                            <h6 class="mb-0 text-sm"><%=mp.player.name.titleize%></h6>
                            <p class="text-xs text-secondary mb-0"><%=mp.player.cellphone%></p>
                          </div>
                        </div>
                      </td>
                      <td>                        
                        <div class="d-flex flex-column justify-content-center">
                          <%if mp.status=='OnBoard' %>
                            <span class="badge badge-sm bg-gradient-success"><%=mp.status%></span>
                          <%else%>
                            <span class="badge badge-sm bg-gradient-danger"><%=mp.status%></span>
                          <%end%>                          
                        </div>                        
                      </td>
                      <td>

                        <div class="d-flex flex-column justify-content-left"> 
                            <h6 class="mb-0 text-sm"><%= local_time(mp.created_at, %"%d/%m/%Y %H:%M:%S")%></h6>
                          
                          </div>
                        </div>                      
                      </td>
                      <td>
                        <div> 
                        <% if @event.status.upcase != "CLOSED"%>
                          <%= link_to(mp, data: {turbo_method: :delete, turbo_confirm: 'Are you sure?'}, class: "btn btn-sm btn-danger ms-auto") do %>
                                <i class="fa fa-sign-out"></i>&nbsp;&nbsp;Quit
                          <%end%>
                        <%end%>
                        </div>
                      </td>
                    </tr>
                    <%end%>
                  </tbody>
                </table>
              </div>
            </div>


            

            

          </div>
        </div>
    </div>
</div>

app/views/match_players/new.html.erb
<!-- 
<h3 style= "color: white">New player to the match</h3>
-->
<h3>&nbsp;</h3>
<%= render "form", match_player: @match_player, event: @event %>